package edu.swarthmore.cs.cs71.lecture.junit.tests;

import edu.swarthmore.cs.cs71.lecture.junit.LightsOutModel;
import edu.swarthmore.cs.cs71.lecture.junit.LightsOutModelImpl;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class LightsOutModelTests {
    @Test
    public void testGetSpaceState() {
        LightsOutModel model = new LightsOutModelImpl();
        for (int y = 0; y < 3; y++) {
            for (int x = 0; x < 3; x++) {
                model.getSpaceState(x, y);
            }
        }
    }

    @Test
    public void testCenterClick() {
        boolean[][] lights = new boolean[3][3];
        LightsOutModel model = new LightsOutModelImpl();
        for (int y = 0; y < 3; y++) {
            for (int x = 0; x < 3; x++) {
                lights[x][y] = model.getSpaceState(x, y);
                if (x == 1 || y == 1) {
                    lights[x][y] = !lights[x][y];
                }
            }
        }
        model.toggleSpace(1, 1);
        for (int y = 0; y < 3; y++) {
            for (int x = 0; x < 3; x++) {
                Assertions.assertEquals(lights[x][y], model.getSpaceState(x,y));
            }
        }
    }
}
